<?php
require_once CLASS_EX_REALDIR . 'page_extends/admin/LC_Page_Admin_Ex.php';

class LC_Page_Admin_Design_Nav extends LC_Page_Admin_Ex {

    /**
     * Page を初期化する.
     *
     * @return void
     */
    public function init() {
        parent::init();
        $this->tpl_mainpage = 'design/nav.tpl';
        $this->tpl_subno = 'nav';
        $this->tpl_mainno = 'design';
        $this->tpl_maintitle = 'デザイン管理';
		$this->tpl_subtitle = 'ナビ色管理';
    }

    /**
     * Page のプロセス.
     *
     * @return void
     */
    public function process() {
        $this->action();
        $this->sendResponse();
    }

    /**
     * Page のアクション.
     *
     * @return void
     */
    public function action() {

        $objDb = new SC_Helper_DB_Ex();

        if ($objDb->sfGetBasisExists()) {
            $this->tpl_mode = 'update';
        } else {
            $this->tpl_mode = 'insert';
        }

        if (!empty($_POST)) {

            $objFormParam = new SC_FormParam_Ex();
            $this->lfInitParam($objFormParam, $_POST);
            $objFormParam->setParam($_POST);
            $objFormParam->convParam();

            $this->arrErr = $this->lfCheckError($objFormParam);
            $post = $objFormParam->getHashArray();

            $this->arrForm = $post;

            if (count($this->arrErr) == 0) {
                switch ($this->getMode()) {
                    // 既存編集
                    case 'update':
                        $this->lfUpdateData($this->arrForm);
                        break;
                    // 新規作成
                    case 'insert':
                        $this->lfInsertData($this->arrForm);
                        break;
                    default:
                        break;
                }
                $this->tpl_onload = "window.alert('ナビ色の登録が完了しました。');";
            }
        } else {
            $arrCol = $this->lfGetCol();
            $col    = SC_Utils_Ex::sfGetCommaList($arrCol);
            $arrRet = $objDb->sfGetBasisData(true, $col);
            $this->arrForm = $arrRet;
        }

        //サブタイトルを取得
	    $this->tpl_subtitle = 'レスポンシブWebデザイン＞' . $this->tpl_subtitle;
    }

    // 基本情報用のカラムを取り出す。
    public function lfGetCol() {
        $arrCol = array(
            'nav_font',
            'nav_bgcolor',
            'nav_lihover',
			'global_font',
			'global_bgcolor',
			'global_lihover',
        );
        return $arrCol;
    }

    public function lfUpdateData($array) {
        $objQuery =& SC_Query_Ex::getSingletonInstance();
        $arrCol = $this->lfGetCol();
        foreach ($arrCol as $val) {
            //配列の場合は、パイプ区切りの文字列に変換
            if (is_array($array[$val])) {
                $sqlval[$val] = implode('|', $array[$val]);
            } else {
                $sqlval[$val] = $array[$val];
            }
        }
        $sqlval['update_date'] = 'CURRENT_TIMESTAMP';
        // UPDATEの実行
        $ret = $objQuery->update('dtb_baseinfo', $sqlval);

        GC_Utils_Ex::gfPrintLog('dtb_baseinfo に UPDATE を実行しました。');
    }

    public function lfInsertData($array) {
        $objQuery =& SC_Query_Ex::getSingletonInstance();
        $arrCol = $this->lfGetCol();
        foreach ($arrCol as $val) {
            $sqlval[$val] = $array[$val];
        }
        $sqlval['id'] = 1;
        $sqlval['update_date'] = 'CURRENT_TIMESTAMP';
        // INSERTの実行
        $ret = $objQuery->insert('dtb_baseinfo', $sqlval);

        GC_Utils_Ex::gfPrintLog('dtb_baseinfo に INSERT を実行しました。');
    }

    public function lfInitParam(&$objFormParam, $post) {
        $objFormParam->addParam('ナビ文字色', 'nav_font', STEXT_LEN, 'KVa',  array('EXIST_CHECK', 'MAX_LENGTH_CHECK'));
        $objFormParam->addParam('ナビ背景色', 'nav_bgcolor', STEXT_LEN, 'KVa',  array('EXIST_CHECK', 'MAX_LENGTH_CHECK'));
        $objFormParam->addParam('ナビオンマウス時', 'nav_lihover', STEXT_LEN, 'KVa', array('EXIST_CHECK', 'MAX_LENGTH_CHECK'));
        $objFormParam->addParam('グローバルナビ文字色', 'global_font', STEXT_LEN, 'KVa',  array('EXIST_CHECK', 'MAX_LENGTH_CHECK'));
        $objFormParam->addParam('グローバルナビ下線色', 'global_bgcolor', STEXT_LEN, 'KVa',  array('EXIST_CHECK', 'MAX_LENGTH_CHECK'));
        $objFormParam->addParam('グローバルナビオンマウス時', 'global_lihover', STEXT_LEN, 'KVa', array('EXIST_CHECK', 'MAX_LENGTH_CHECK'));
    }

    // 入力エラーチェック
    public function lfCheckError(&$objFormParam) {
        $arrErr = $objFormParam->checkError();
        $post = $objFormParam->getHashArray();

        $objErr = new SC_CheckError_Ex($post);

        return array_merge((array)$arrErr, (array)$objErr->arrErr);
    }
}
